﻿local L = LibStub("AceLocale-3.0"):GetLocale("AVRE")
local zones = LibStub("AceLocale-3.0"):GetLocale("AVRE Zones")
local AVRE = AVRE
if not AVRE or not AVR then return end



--[[
      VARIABLES ----------------------------------------------------------------------------------------------------------------
  ]]




--[[
      UPVALUES -----------------------------------------------------------------------------------------------------------------
  ]]
  
local _G = getfenv(0)
local pairs = _G.pairs
local strlower = _G.strlower
local strupper = _G.strupper
local format = _G.format

local UnitAffectingCombat = _G.UnitAffectingCombat
local UnitGUID = _G.UnitGUID
local UnitName = _G.UnitName
local UnitInRaid = _G.UnitInRaid
local UnitIsDeadOrGhost = _G.UnitIsDeadOrGhost



--[[
      TESTS --------------------------------------------------------------------------------------------------------------------
  ]]

local testSubjectYou = "Állara"
local testSubjectOther = "Ánara"

function AVRE:Test(test, index)
	AVRE.testing = true
	if (AVRE.fight and AVRE.fight.enable.fight ~= test) or not AVRE.fight then
		AVRE:StartFight(AVRE.enc[test], 0, true)
	end
	
	if test == "marrowgar" then
		if index == 1 then
			AVRE:OnCombatEvent("", GetTime(), "SPELL_SUMMON", "0x108086391105549245", testSubjectOther, 0, "0x108086391084506960", "Bone Spike", 0, 69062, "")
			
		elseif index == 2 then
			AVRE:OnCombatEvent("", GetTime(), "UNIT_DIED", "0x108086391105549245", testSubjectOther, 0, "0x108086391084506960", "Bone Spike", 0, 69062, "")
		
		elseif index == 3 then
			AVRE:OnCombatEvent("", GetTime(), "SPELL_SUMMON", "0x108086391105549245", testSubjectOther, 0, "0x108086391084506960", "Bone Spike", 0, 69062, "")
			
		elseif index == 4 then
			AVRE:OnCombatEvent("", GetTime(), "UNIT_DIED", "0x108086391105549245", testSubjectOther, 0, "0x108086391105549245", testSubjectOther, 0, 69062, "")
		
		end
	
	elseif test == "festergut" then
		self:StartFight(AVRE.enc[test], 0, true)
		AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_APPLIED", "0x108086391105549245", "Festergut", 0, "0x108086391084506960", testSubjectOther, 0, 69279, "")

	elseif test == "rotface" then
		self:StartFight(AVRE.enc[test], 0, true)
		AVRE:OnCombatEvent("", GetTime(), "SPELL_CAST_START", "0x108086391105549245", "src", 0, "0x108086391084506960", "dst", 0, 69839, "")
	
	elseif test == "putricide" then
		if index == 1 then
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_APPLIED", "0x108086391105549245", "Professor Putricide", 0, "0x108086391084506960", testSubjectYou, 0, 72855, "")
			
		elseif index == 2 then
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_APPLIED", "0x108086391105549245", "Professor Putricide", 0, "0x108086391084506960", testSubjectOther, 0, 70953, "")
			
		elseif index == 3 then
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_REMOVED", "0x108086391105549245", "Professor Putricide", 0, "0x108086391084506960", testSubjectOther, 0, 70953, "")
			
		elseif index == 4 then
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_REMOVED", "0x108086391105549245", "Professor Putricide", 0, "0x108086391084506960", testSubjectYou, 0, 72855, "")
			
		elseif index == 5 then
			AVRE:ForceBossTarget(36678, testSubjectYou)
			AVRE:OnCombatEvent("", GetTime(), "SPELL_CAST_SUCCESS", "0x108086391105549245", "Professor Putricide", 0, "0x108086391084506960", testSubjectYou, 0, 72615, "")
			AVRE:ClearForcedBossTarget(0.5)
			
		end
	
	elseif test == "bloodprince" then
		if index == 1 then
			self:OnEvent("CHAT_MSG_RAID_BOSS_EMOTE", format("Empowered Flames speed toward %s!", testSubjectYou), "", "", "", testSubjectYou)
			
		elseif index == 2 then
			AVRE:ForceBossTarget(37970, testSubjectYou)
			AVRE:OnCombatEvent("", GetTime(), "SPELL_CAST_START", "0x108086391105549245", "", 0, "0x108086391084506960", testSubjectYou, 0, 72037, "")
			AVRE:ClearForcedBossTarget(0.5)
		
		end
	
	elseif test == "sindragosa" then
		if index == 1 then
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_APPLIED", "0x108086391105549245", "Sindragosa", 0, "0x108086391084506960", testSubjectYou, 0, 70126, "")
			
		elseif index == 2 then
			self:ForceHeroic(true)
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_APPLIED", "0x108086391105549245", "Sindragosa", 0, "0x108086391084506960", testSubjectOther, 0, 69762, "")
			self:ForceHeroic(nil)
			
		elseif index == 3 then
			self:ForceHeroic(true)
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_REMOVED", "0x108086391105549245", "Sindragosa", 0, "0x108086391084506960", testSubjectOther, 0, 69762, "")
			self:ForceHeroic(nil)
			
		end
	
	elseif test == "lichking" then
		if index == 1 then
			AVRE:ForceBossTarget(36597, testSubjectYou)
			AVRE:OnCombatEvent("", GetTime(), "SPELL_CAST_START", "0x108086391105549245", "", 0, "0x108086391084506960", testSubjectYou, 0, 72762, "")
			AVRE:ClearForcedBossTarget(0.5)
			
		elseif index == 2 then
			AVRE:ForceBossTarget(36597, testSubjectYou)
			AVRE:OnCombatEvent("", GetTime(), "SPELL_CAST_START", "0x108086391105549245", "", 0, "0x108086391084506960", testSubjectYou, 0, 73539, "")
			AVRE:ClearForcedBossTarget(0.5)
		
		end
	
	else
		self:Print(format("Unknown test: %s", test))
	
	end
	
	AVRE.testing = false
end



--[[
      TEST DRIVER --------------------------------------------------------------------------------------------------------------
  ]]

local testDriver = {
	{ "marrowgar", 1, "Bone Spike", 9 },
	{ "marrowgar", 2, "-- spike died --", 2 },
	{ "marrowgar", 3, "Bone Spike", 9 },
	{ "marrowgar", 4, "-- player died --", 2 },
	{ "festergut", 1, "Gas Spore", 14 },
	{ "rotface", 1, "Explosion", 12 },
	{ "putricide", 1, "Unbound Plague on you", 3 },
	{ "putricide", 2, "Plague Sickness on someone else", 3 },
	{ "putricide", 3, "-- plague sickness --", 2 },
	{ "putricide", 4, "-- unbound plague --", 2 },
	{ "putricide", 5, "Malleable Goo", 7 },
	{ "bloodprince", 1, "Empowered Flame", 8 },
	{ "bloodprince", 2, "Shock Vortex", 7 },
	{ "sindragosa", 1, "Frost Beacon", 8 },
	{ "sindragosa", 2, "Unchained Magic (heroic)", 5 },
	{ "sindragosa", 3, "-- unchained magic (early) --", 2 },
	{ "lichking", 1, "Defile", 4 },
	{ "lichking", 2, "Shadow Trap", 6 },
}



--[[
      METHODS ------------------------------------------------------------------------------------------------------------------
  ]]

do
	local count = 0
	local cur = 1
	local defaultDelay
	local stop = 0
	
	local function doTest(v)
		AVRE:Print(format("[%d/%d]: %s %d (%s) for %d seconds", cur, count, v[1], v[2], v[3], v[4] or defaultDelay))
		AVRE:Test(v[1], v[2])
		cur = cur + 1
		if cur <= count and cur <= stop then
			AVRE:ScheduleTimer(function() doTest(testDriver[cur]) end, testDriver[cur-1][4] or defaultDelay)
		else
			AVRE:Print("Done with tests")
		end
	end
	
	function AVRE:RunTests(start, e, del)
		count = 0
		cur = 1
		if not del then defaultDelay = 10 else defaultDelay = del end
		for k, v in pairs(testDriver) do
			count = count + 1
		end
		if start and start <= count then cur = start end
		stop = count
		if e and e <= count then stop = e end
		doTest(testDriver[cur])
	end
	
end


function AVRE:TestZone(zone)
	AVRE.testZone = zone
	self:LoadZone()
end


function AVRE:ForceHeroic(value)
	AVRE.forceHeroic = value
end


function AVRE:ForceBossTarget(id, name)
	AVRE.forcedTargetNpc = id
	AVRE.forcedTargetName = name
end


function AVRE:ClearForcedBossTarget(delay)
	self:ScheduleTimer(function() self:ForceBossTarget(nil, nil) end, delay)
end


function AVRE:SetTestSubjectYou(n)
	testSubjectYou = n
end


function AVRE:SetTestSubjectOther(n)
	testSubjectOther = n
end
